function [visitedNodes_tau, vector_tau, maxPosiOfQuery, influ_tau] = ...
    ChainSnake_OneStep(targetLists, alpha, beta, tau, tailLength, visitedNodes_tau_1, vector_tau_1, ...
    influ_tau_1, maxPosiOfQuery, probThresh)

if tau == numel(maxPosiOfQuery) 
    influWeight = beta^(tau - 1);
else
    error('Input weight vector error !');
end

[visitedNodes_temp, vector_temp] = SparseMatrixByVector_visited(targetLists, visitedNodes_tau_1, vector_tau_1);
vector_temp = alpha * vector_temp;
 
cDegree = numel(influ_tau_1(:, 1));
for i = 1:cDegree
    indexOfInfleEntry = influ_tau_1(i, 1);
    includeYet = find(visitedNodes_temp == indexOfInfleEntry);
    if isempty(includeYet)
        visitedNodes_temp(end + 1, 1) = indexOfInfleEntry;
        vector_temp(end + 1, 1) =  (1 - alpha) * influ_tau_1(i, 2);
    elseif numel(includeYet) == 1
        vector_temp(includeYet, 1) = vector_temp(includeYet, 1) + (1 - alpha) * influ_tau_1(i, 2);
    else
        error('There are multiple found indices !!! ');
    end
end
if max(vector_temp) > probThresh
	visitedNodesIndices = vector_temp > probThresh;
else
	if numel(vector_temp) > 1000
		visitedNodesIndices = false(numel(vector_temp), 1);
		randomIndex = randperm(numel(vector_temp), 1000);
		visitedNodesIndices(randomIndex) = true;
	else
		visitedNodesIndices = vector_temp > 1e-6;
	end
end

visitedNodes_tau = visitedNodes_temp(visitedNodesIndices);
vector_tau = vector_temp(visitedNodesIndices)/norm(vector_temp(visitedNodesIndices), 1);
    
maxPosiOfQuery{end + 1, 1} = visitedNodes_tau(vector_tau > max(vector_tau) - 1e-10);

%--------------------------------------------------------------------------
% Update influential vector

influ_tau = influ_tau_1;
influ_tau(:, 2) =  (1 - influWeight) * influ_tau_1(:, 2);

influVisitedNodes =  influ_tau(:, 1);
influVector = influ_tau(:, 2);

for j = 1:tailLength
    if j <= numel(maxPosiOfQuery)
        cMaxPosition = maxPosiOfQuery{end + 1 - j};
    else
        cMaxPosition = maxPosiOfQuery{1};
    end
    [influVisitedNodes, influVector] = EffectAddedVector_visited(targetLists, influVisitedNodes, influVector,...
        cMaxPosition, influWeight/tailLength);
end
influ_tau= [influVisitedNodes influVector];

