function [conductance,sortTopLVector,comm] = ComputeConductanceAggr(adjacentList, targetLists, visitedNodes, visitedScore, topL)
noOfDirectEdges = sum(adjacentList(:,3)); % 2*num of undirected edges

sortTopLVector = [];
tempVisitedScore = visitedScore;

noOfCrossEdge = 0;
volume = 0;
conductance = [];
minCond = 1;
minCondIndex = 0;
for i = 1:min(topL, numel(visitedNodes))
    [maxValue, tempMaxIndex] = max(tempVisitedScore); 
    noOfMax = numel(tempMaxIndex); 
    sortTopLVector(end + 1 : end + noOfMax, 2) = maxValue;
    if size(tempMaxIndex, 2) > 1
        tempMaxIndex = tempMaxIndex';
    end
    addedNodes = visitedNodes(tempMaxIndex);
    sortTopLVector(end + 1 - noOfMax : end, 1) = addedNodes;
    tempVisitedScore(tempMaxIndex) = -1000;
    
    noOfSorted = size(sortTopLVector, 1);
    for j = 1:noOfMax
        currentNode = addedNodes(j);
        currentEdgeSet = targetLists{currentNode};
        volume = volume + numel(currentEdgeSet);
        addedCrossEdges = setdiff(currentEdgeSet, sortTopLVector(1:(noOfSorted-noOfMax+j-1),1));
        noOfCrossEdge = noOfCrossEdge + numel(addedCrossEdges) - (numel(currentEdgeSet) - numel(addedCrossEdges));
        conductance(end + 1, 1) = noOfCrossEdge/min(volume,noOfDirectEdges - volume);
        if conductance(end) < minCond
            minCond = conductance(end);
            minCondIndex = noOfSorted - noOfMax + j;
        end
    end
 
end

if minCondIndex > 0
    comm = sortTopLVector(1 : minCondIndex,1);
else
    comm = [];
end
