function [membership, repreIndex, interMatrices_pre, interMatrices, newVisitedNodes, newVectorsOfQueryNodes] = Interactions_vector_reduceR_correctOrder(noOfNodes, ...
    noOfQueryNodes, preVisitedNodes, preVectors, weight, probThresh, convergeThreshold, membership, repreIndex)
% theta: para of distance function
% weight: weight of retainning its own matrix

newVectorsOfQueryNodes = preVectors;
newVisitedNodes = preVisitedNodes;
distance = zeros(noOfQueryNodes, noOfQueryNodes);
interMatrices = zeros(noOfQueryNodes, noOfQueryNodes);
for i = 1:noOfQueryNodes
    if repreIndex(i) == 0 
        nodesSet_1 = preVisitedNodes{i};
        vector_1 = preVectors{i};
        for j = (i + 1):noOfQueryNodes
            if repreIndex(j) == 0 
                nodesSet_2 = preVisitedNodes{j};
                vector_2 = preVectors{j};
                [compareNodes, i_1, i_2] = intersect(nodesSet_1, nodesSet_2);
                
                if ~isempty(compareNodes)
                    otherInd_1 = true(numel(nodesSet_1),1);
                    otherInd_1(i_1) = false;
                    unionVector_1 = [vector_1(i_1); vector_1(otherInd_1); zeros(numel(nodesSet_2) - numel(i_2),1)];

                    otherInd_2 = true(numel(nodesSet_2),1);
                    otherInd_2(i_2) = false;
                    unionVector_2 = [vector_2(i_2); zeros(numel(nodesSet_1) - numel(i_1), 1); vector_2(otherInd_2)];

                    distance(i,j) =  sum(vector_1(i_1).*vector_2(i_2))/norm(vector_1)/norm(vector_2);

                    distance(j,i) = distance(i,j);
                else
                    distance(i,j) = -1;
                    distance(j,i) = distance(i,j);
                end
            elseif repreIndex(j) > 0 && repreIndex(j) ~= i
                distance(i,j) = distance(i, repreIndex(j));
                distance(j,i) = distance(i,j);
            elseif repreIndex(j) == i
                distance(i,j) = 1;
                distance(j,i) = distance(i,j);
            end
             
                
        end
    else
        distance(i, i + 1 : noOfQueryNodes) = distance(repreIndex(i),  i + 1 : noOfQueryNodes);
        distance(i + 1 : noOfQueryNodes, i) =  distance(i, i + 1 : noOfQueryNodes)';
    end
    
end

similarityThresh = 1e-10;
interMatrices(distance > similarityThresh) = distance(distance > similarityThresh);
interMatrices_pre = interMatrices;


[membership, repreIndex, preVisitedNodes, preVectors] =...
    MergeNodesAndVectors(interMatrices_pre, convergeThreshold, membership, repreIndex, preVisitedNodes, preVectors);


for i = 1:noOfQueryNodes
    if norm(interMatrices(:,i), 1) > 0
        interMatrices(:,i) = interMatrices(:,i) / norm(interMatrices(:,i), 1);
    else
        continue;
    end
end
for i = 1:noOfQueryNodes
     if repreIndex(i) == 0  && sum(interMatrices(:, i)) > 0 

        nodesSet_1 = preVisitedNodes{i};
        vector_1 = preVectors{i};

        vector_i = zeros(noOfNodes, 1);
        vector_i(nodesSet_1) = weight * vector_1;

        interPosiIndex = find(interMatrices(:, i) > 0);
        interPosiIndex = interPosiIndex';
        for k = interPosiIndex(1:end)
            vector_i(preVisitedNodes{k}) = vector_i(preVisitedNodes{k}) + interMatrices(k,i) * preVectors{k};
        end
        vector_i = vector_i/(weight + 1);

        visitedNodes = find(vector_i > probThresh);
        newVisitedNodes{i} = visitedNodes;

        newVectorsOfQueryNodes{i} = vector_i(visitedNodes)/norm(vector_i(visitedNodes), 1);
     elseif repreIndex(i) ~= 0
        newVisitedNodes{i} = newVisitedNodes{repreIndex(i)};
        newVectorsOfQueryNodes{i} = newVectorsOfQueryNodes{repreIndex(i)};
        continue;
     else
        newVisitedNodes{i} = preVisitedNodes{i};
        newVectorsOfQueryNodes{i} = preVectors{i};
        continue;
    end
end


