function [score, commOfQueryNodes_OR, interMatrices, measure]...
        = MQLC_vectors_con_T_reduceR(graphPath, graphData, queryNodes, communityGroundtruth, weight, epsilon, tauStop, probThresh, alpha, beta,... 
        tailLength, convergeThreshold)
    
load(strcat(graphPath, graphData,'/result_',graphData,'_modified_index.mat'));
adjacentList = double(eval(strcat(graphData,'_adjacentList')));
targetLists = eval(strcat(graphData,'_targetLists'));

close all;
iterationNo = 1;
queryPerCluster = 1;

noOfQueryNodes = numel(queryNodes);
noOfNodes = numel(targetLists);

for i = 1:noOfQueryNodes
    queryNodes(i) = find(adjacentList(:, 2) == queryNodes(i));
end

vectorsOfQueryNodes = cell(noOfQueryNodes, 1);
visitedNodesOfQueryNodes = cell(noOfQueryNodes, 1);
score = cell(noOfQueryNodes, 1);
maxPosiOfQueryNodes = cell(noOfQueryNodes, 1);

visitedNodesOfQueryNodes_mid = visitedNodesOfQueryNodes;
vectorsOfQueryNodes_mid = vectorsOfQueryNodes;

commOfQueryNodes = cell(noOfQueryNodes, 1);
commOfQueryNodes_OR = cell(noOfQueryNodes, 1);
measure = zeros(noOfQueryNodes, 3);
residual = zeros(noOfQueryNodes, 1);

influVectorsOfQueryNodes = cell(noOfQueryNodes, 1);
interMatrices = zeros(noOfQueryNodes, noOfQueryNodes);
interMatrices_pre = zeros(noOfQueryNodes, noOfQueryNodes);
membership = cell(noOfQueryNodes, 1);
repreIndex = zeros(noOfQueryNodes, 1);
checkIndex = [1:noOfQueryNodes]';

for j = 1:noOfQueryNodes
    vectorsOfQueryNodes{j} = ones(queryPerCluster, 1)/queryPerCluster;
    visitedNodesOfQueryNodes{j} = queryNodes((j - 1) * queryPerCluster + 1 : j * queryPerCluster, 1);
    maxPosiOfQueryNodes{j} = {queryNodes((j - 1) * queryPerCluster + 1 : j * queryPerCluster, 1)};
    
    influVectorsOfQueryNodes{j} = [queryNodes((j - 1) * queryPerCluster + 1 : j * queryPerCluster, 1) ones(queryPerCluster, 1)/queryPerCluster];
end
convergeFlagOfQueryNodes = zeros(noOfQueryNodes, 1);
repreFlagOfQueryNodes = zeros(noOfQueryNodes, 1);
convergeFlag = false;

while convergeFlag == false && iterationNo < tauStop
    for i = 1:noOfQueryNodes
        if convergeFlagOfQueryNodes(i) == 0 && repreFlagOfQueryNodes(i) == 0
            
            [cVisitedNodes, cVector, cMaxPosi, cInfluVector] = ...
                ChainSnake_OneStep(targetLists, alpha, beta, iterationNo, tailLength,  visitedNodesOfQueryNodes{i}, vectorsOfQueryNodes{i}, ...
                influVectorsOfQueryNodes{i}, maxPosiOfQueryNodes{i}, probThresh);
  
            visitedNodesOfQueryNodes_mid{i} = cVisitedNodes;
            vectorsOfQueryNodes_mid{i} = cVector;
            maxPosiOfQueryNodes{i} = cMaxPosi;

            influVectorsOfQueryNodes{i} = cInfluVector;
        elseif repreFlagOfQueryNodes(i) == 1
            visitedNodesOfQueryNodes_mid{i} = visitedNodesOfQueryNodes{repreIndex(i)};
            vectorsOfQueryNodes_mid{i} = vectorsOfQueryNodes{repreIndex(i)};
            continue;
        else
            visitedNodesOfQueryNodes_mid{i} = visitedNodesOfQueryNodes{i};
            vectorsOfQueryNodes_mid{i} = vectorsOfQueryNodes{i};
            continue;
        end
    end
        
    %------- interactions with others---------------------
    [membership, repreIndex, interMatrices_pre, interMatrices, visitedNodesOfQueryNodes_temp, vectorsOfQueryNodes_temp] = ...
        Interactions_vector_reduceR_correctOrder(noOfNodes, noOfQueryNodes, ...
        visitedNodesOfQueryNodes_mid, vectorsOfQueryNodes_mid, weight, probThresh, convergeThreshold, membership, repreIndex);
      
    repreFlagOfQueryNodes(repreIndex > 0) = 1;
    
    for i = 1:noOfQueryNodes
        if convergeFlagOfQueryNodes(i) == 0 && repreFlagOfQueryNodes(i) == 0

            vector_tau_t = zeros(noOfNodes, 1);
            vector_tau_1_t = vector_tau_t;
            vector_tau_t(visitedNodesOfQueryNodes_temp{i}) = vectorsOfQueryNodes_temp{i};
            vector_tau_1_t(visitedNodesOfQueryNodes{i}) = vectorsOfQueryNodes{i};

            residual(i) = norm(vector_tau_t - vector_tau_1_t, Inf);

            if residual(i) < epsilon
                convergeFlagOfQueryNodes(i) = 1;
            else
                visitedNodesOfQueryNodes{i} = visitedNodesOfQueryNodes_temp{i};
                vectorsOfQueryNodes{i} = vectorsOfQueryNodes_temp{i};
            end      
        elseif repreFlagOfQueryNodes(i) == 1
            visitedNodesOfQueryNodes{i} = visitedNodesOfQueryNodes{repreIndex(i)};
            vectorsOfQueryNodes{i} = vectorsOfQueryNodes{repreIndex(i)};
            continue;
        else
            continue;
        end
    end
    
    if sum(convergeFlagOfQueryNodes | repreFlagOfQueryNodes) == noOfQueryNodes
        convergeFlag = true;
        break;
    end
    
    iterationNo = iterationNo + 1;
    
end

checkIndex(repreIndex > 0) = repreIndex(repreIndex > 0);

uniqueClusterNo = 0;
for i = 1:noOfQueryNodes 
    if checkIndex(i) == i
        cVector = vectorsOfQueryNodes{i};
        [~,~,cComm] = ComputeConductanceAggr(adjacentList, targetLists, visitedNodesOfQueryNodes{i}, cVector, 100);
        uniqueClusterNo = uniqueClusterNo + 1;
    elseif checkIndex(i) < i
        cComm = commOfQueryNodes{checkIndex(i)};
    end
    commOfQueryNodes{i} = cComm;   
    
    commOfQueryNodes_OR{i} = adjacentList(cComm, 2);

    cCommGround = communityGroundtruth{i * queryPerCluster};
 
    measure(i, :) = ComputeFScore(commOfQueryNodes_OR{i},cCommGround);
    
    score{i} = sortrows([adjacentList(visitedNodesOfQueryNodes{i}, 2) vectorsOfQueryNodes{i}], -2);
    
end


