function [membership, repreIndex, visitedNodes, vectors] = MergeNodesAndVectors(interMatrices_pre, convergeThreshold, membership, repreIndex, visitedNodes, vectors)

noOfQueryNodes = size(interMatrices_pre, 1);
for i = 1:noOfQueryNodes
    if ~isempty(membership{i})
        interMatrices_pre(i, membership{i}) = -1;
        interMatrices_pre(membership{i}, i) = -1;
    end
end


for i = 1:noOfQueryNodes

        [maxR, maxFirstIndex] = max(interMatrices_pre(i, :));
        if maxR >= convergeThreshold && maxFirstIndex < i
            membership{i}(end + 1) = maxFirstIndex;
            
            repreIndex(i) = min(membership{i});
            
            visitedNodes_1 = visitedNodes{i};
            visitedNodes_2 = visitedNodes{maxFirstIndex};
            vectors_1 = vectors{i};
            vectors_2 = vectors{maxFirstIndex};
            
            [mergedNodes, mergedVectors] = MergeTwoVectors(visitedNodes_1, visitedNodes_2, vectors_1, vectors_2);
            
            visitedNodes{i} = mergedNodes;
            vectors{i} = mergedVectors;
            visitedNodes{maxFirstIndex} = mergedNodes;
            vectors{maxFirstIndex} = mergedVectors;
        end

end
        
