function [updatedVisitedNodes, updatedVisitedVector]=SparseMatrixByVector_visited...
    (targetLists, visitedNodes, visitedVector)
% ------Input------
% adjacentList:
% 1 column: the index (1 to #node);
% 2 column: the sorted original node index;
% 3 column: the total degree with weight info for weighted graph, pure
% degree for unweighted graph
% (opt)4 column: the pure degree without weight info, for unweighted graph, this
% is the 3 column

% targetLists: edges incident with the node (the edges set order may not be sorted)
% vertorq: the column score of t-th iteration

% ------Output------
% resultVector: the column score of (t+1)-th iteration

updatedVisitedNodes = [];
updatedVisitedVector = [];

weightFlag = false;
if weightFlag == false

    noOfVisitedNodes = numel(visitedNodes);
    for i = 1:noOfVisitedNodes
        cVisitedNode = visitedNodes(i);
        tempTargetList = targetLists{cVisitedNode,1};
        cDegree = numel(tempTargetList);
        
        for indexOfDirectNeigh = tempTargetList(1:cDegree)
            includeYet = find(updatedVisitedNodes == indexOfDirectNeigh);
            if isempty(includeYet)
                updatedVisitedNodes(end + 1, 1) = indexOfDirectNeigh;
                updatedVisitedVector(end + 1, 1) = visitedVector(i)/cDegree;
            elseif numel(includeYet) == 1
                updatedVisitedVector(includeYet, 1) = updatedVisitedVector(includeYet, 1) + visitedVector(i)/cDegree;
            else
                error('There are multiple found indices !!! ');
            end
        end
    end
end
